# ci-version-plugin

## Purpose
The plugin is used to support automated pipeline by generating automatic versioning and ability to use ranges in the pom. This is part of tooling that provides for consistent reproduction of builds even when ranges are used. The reproduceable versioned pom (with ranges resolved) is saved in a branch and appropriately tagged.
The plugin does the following
* Generate a new version number based on what is in the pom and tags in the git repository.
* It will resolve ranges and generate a report of resolved ranges.
* It will (by default options) tag the current branch with a version tag and `s` as prefix.
* it will then checkout a new branch with the version under `ci-version` branch.
* It will save the pom with the new version and ranges resolved.
* It will then commit the changes and tag the branch with the version tag and `v` as prefix.

## Requirements and limitations
* The versioning scheme used is major.minor.incremental-buildNumber
* All parts of the version MUST be numeric with the exception that the buildNumber can say `SNAPSHOT`.
* The pipeline will only update the incremental and buildNumber and stay within the same major and minor number in the pom. Major and minor number definition is responsibility of developer/team and reflected in pom.
* The incremental number gets bumped on wednesday (Hump Day).
* For multi module poms, strict guideline MUST be followed
  * child module pom MUST not have group or version specified
  * child module pom MUST be in same git project and have main project as parent.
* Limitations
  * Only supports GIT repository

## usage
```
mvn  com.d4iot.oss.plugin.ci:ci-version-plugin:1.0.0-5::ci-version
```

## Configuration options
* versionRangeCleanup
  * type: boolean
  * default: true
  * If true will clean up non-numeric versions generated by maven metadata.
* tagSCM
  * type: boolean
  * default: true
  * If true will tag the current commit with a tag prefixed with `s`. Example s1.0.0-1
* branchAndTagSCM
  * type: boolean
  * default: true
  * If true it will create a git branch named ci-version/vA.B.C-D where A.B.C-D is the new version number. Once it has saved the updated poms to disk, it will commit and add the tag vA.B.C-D

## Use Cases
### Enable automatic dependent build triggers in CI pipeline
The generated json manifest is passed to down-stream jobs to add support for auto-detection of dependent (artifacts based on ranges provided) and thus triggering those jobs.

### Automatic versioning as part of the pipeline
Automatic versioning defined as part of pipeline that is mainly geared towards projects that have rapid(weekly or less) release schedules.

## Sample Output
```
{
    "project": {
        "artifactId": "standards-oss",
        "groupId": "com.d4iot.oss.standards",
        "versionNew": "1.8.15-12",
        "versionOld": "1.8.0-3"
    },
    "dependencies": [
        {
            "artifactId": "jsoniter",
            "groupId": "com.jsoniter",
            "versionNew": "0.9.23",
            "versionOld": "[0.9,0.10)"
        },
        {
            "artifactId": "slf4j-api",
            "groupId": "org.slf4j",
            "versionNew": "1.7.26",
            "versionOld": "[1.7,8)"
        }
    ],
    "scmId": "66ceb3c21b7b65af6db16c198d335c5cb98378b8"
}
```
